/* updated */

#ifndef V_GPSP_H
#define V_GPSP_H

/*
 * General-purpose one-dimensional spline interpolator object.
 */

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/* Creates interpolator for given ordered x_i and y_i */
	vhandle_t	V_GLOBAL	cspCreate(vector_t *vx,vector_t *vy);
    /* Returns interpolated y for given x */
	vec_t	V_GLOBAL	cspInterpolate(vhandle_t interp, vec_t x);
    /* Re-creates interpolator for new data set */ 
	void	V_GLOBAL	cspChangeX(vhandle_t interp, vector_t *new_x);
	void	V_GLOBAL	cspChangeY(vhandle_t interp, vector_t *new_y);
    /*
     * Changes boundary condition. Parameters:
     *   zero_second_derivative - if 'true', new b.c. will be natural b.c.
     *   f_deriv_l, f_deriv_r - first derivarive at bounds; used only if
     *   zero_second_derivative is 'false'.
     */
	void	V_GLOBAL	cspSetBoundaryCondition(vhandle_t interp,
		vboolean zero_second_derivative, vec_t f_deriv_l, vec_t f_deriv_r);
    /* Closes handle of interpolator */
	void	V_GLOBAL	cspDestroy(vhandle_t interp);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_GPSP_H */
